﻿namespace TabsStudioNavigator
{
    class CommandsImpl
    {
        public CommandsImpl(TabsStudioExt.ITabsStudioEngine engine_, Options options_)
        {
            engine = engine_;
            options = options_;
        }

        public void NavigateToNextTab()
        {
            ShiftToTab(1);
        }

        public void NavigateToPreviousTab()
        {
            ShiftToTab(-1);
        }

        public void NavigateToLastTab()
        {
            TabsStudioExt.Tabs tabs = FindSelectedTabs();
            if (tabs != null)
                ActivateTab(-1, tabs, true);
        }

        public void NavigateToTab(int i)
        {
            TabsStudioExt.Tabs tabs = FindSelectedTabs();
            if (tabs != null)
                ActivateTab(i - 1, tabs, false);
        }

        private void ShiftToTab(int offset)
        {
            TabsStudioExt.Tabs tabs = FindSelectedTabs();
            if (tabs != null)
            {
                foreach (TabsStudioExt.Tab tab in tabs.TabList)
                {
                    if (tab.IsTabSelected)
                    {
                        ActivateTab(tabs.TabPanel2.Children.IndexOf(tab.TabItem) + offset, tabs, options.cycleTab);
                        return;
                    }
                }
            }
        }

        private void ActivateTab(int i, TabsStudioExt.Tabs tabs, bool cycleTab)
        {
            if (cycleTab)
            {
                if (i >= tabs.TabPanel2.Children.Count)
                {
                    i = 0;
                }
                if (i < 0)
                {
                    i = tabs.TabPanel2.Children.Count - 1;
                }
            }
            if (i >= tabs.TabPanel2.Children.Count || i < 0)
                return;
            TabsStudioExt.Tab tabToNavigate =
                FindTabByItem(tabs.TabPanel2.Children[i] as System.Windows.Controls.TabItem, tabs);
            FindActiveExtension(tabToNavigate).Window.Activate();
        }

        private TabsStudioExt.Tab FindTabByItem(System.Windows.Controls.TabItem tabItem, TabsStudioExt.Tabs tabs)
        {
            foreach (TabsStudioExt.Tab tab in tabs.TabList)
            {
                if (tab.TabItem == tabItem)
                    return tab;
            }
            return null;
        }

        private TabsStudioExt.TabExtension FindActiveExtension(TabsStudioExt.Tab tab)
        {
            foreach (TabsStudioExt.TabExtension tabExtension in tab.TabExtensions)
            {
                if (tabExtension.IsExtensionActive)
                    return tabExtension;
            }
            return null;
        }

        private TabsStudioExt.Tabs FindSelectedTabs()
        {
            foreach (TabsStudioExt.Tabs tabs in engine.GetTabs())
            {
                if (tabs.IsGroupSelected)
                    return tabs;
            }
            return null;
        }

        private TabsStudioExt.ITabsStudioEngine engine;
        private Options options;
    }
}
