﻿namespace TabsStudioNavigator
{
    public class Navigator : TabsStudioExt.ITabsStudioAddin, EnvDTE.IDTCommandTarget, TabsStudioExt.IConfigurable
    {
        public void OnConnection(TabsStudioExt.ITabsStudioEngine engine, EnvDTE80.DTE2 dte)
        {
            storage = new OptionsStorage();
            options = storage.Load();
            commandsImpl = new CommandsImpl(engine, options);
            commands = new Commands(engine, dte, commandsImpl);
        }

        public void OnDisconnection()
        {
        }

        public void QueryStatus(string CmdName, EnvDTE.vsCommandStatusTextWanted NeededText,
                ref EnvDTE.vsCommandStatus StatusOption, ref System.Object CommandText)
        {
            commands.QueryStatus(CmdName, NeededText, ref StatusOption, ref CommandText);
        }

        public void Exec(string CmdName, EnvDTE.vsCommandExecOption ExecuteOption, ref System.Object VariantIn,
            ref System.Object VariantOut, ref bool Handled)
        {
            commands.Exec(CmdName, ExecuteOption, ref VariantIn, ref VariantOut, ref Handled);
        }

        public void Configure(System.Windows.Window parent)
        {
            OptionsDialog dialog = new OptionsDialog(options);
            dialog.Owner = parent;
            dialog.WindowStartupLocation = System.Windows.WindowStartupLocation.CenterOwner;
            if (dialog.ShowDialog().GetValueOrDefault())
                storage.Save(options);
        }

        private OptionsStorage storage;
        private Options options;
        private CommandsImpl commandsImpl;
        private Commands commands;
    }
}
